package com.wissamfawaz;

import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeSet;

public class Main {
	private static Map<String, Integer> dictionary = new HashMap<>();

	public static void main(String[] args) {
		String line;
		Scanner scan = new Scanner(System.in);

		System.out.println("Enter a line of text: ");
		line = scan.nextLine();
		
		populateHashMap(line);
		displaySummary();
				
		scan.close();
	}
	
	private static void populateHashMap(String line) {
		line = line.replaceAll("\\p{P}", "");
		String[] words = line.split("\\s+");
		
		for(String word : words) {
			if(dictionary.containsKey(word)) {
				int counter = dictionary.get(word);
				dictionary.put(word, counter+1);
			} else {
				dictionary.put(word, 1);
			}		
			
			//dictionary.getOrDefault(word, 1);
		}
	}
	
	private static void displaySummary() {
		Set<String> wordsSet = dictionary.keySet();
		Set<String> wordsSorted = new TreeSet<>(new WordsComparator());
		
		for(String word : wordsSet) {
			wordsSorted.add(word);
		}
		
		for(String word : wordsSorted) {
			System.out.println(word + " : " + dictionary.get(word));
		}
	}

}
